user/dev discussion of public-inbox itself
 help / color / Atom feed
* [PATCH 0/2] -learn fixes and updates
@ 2020-05-26  9:05 Eric Wong
  2020-05-26  9:05 ` [PATCH 1/2] learn: fix buggy typo on List-ID mapping Eric Wong
  2020-05-26  9:05 ` [PATCH 2/2] learn: support --all with `rm' Eric Wong
  0 siblings, 2 replies; 3+ messages in thread
From: Eric Wong @ 2020-05-26  9:05 UTC (permalink / raw)
  To: meta

I noticed -learn was lacking in some areas while working on
other stuff.  Maybe more consistency improvements with other
CLI tools coming...

Eric Wong (2):
  learn: fix buggy typo on List-ID mapping
  learn: support --all with `rm'

 Documentation/public-inbox-learn.pod |  8 ++++++--
 script/public-inbox-learn            | 11 ++++++++---
 t/mda.t                              | 10 +++++++++-
 3 files changed, 23 insertions(+), 6 deletions(-)

^ permalink raw reply	[flat|nested] 3+ messages in thread

* [PATCH 1/2] learn: fix buggy typo on List-ID mapping
  2020-05-26  9:05 [PATCH 0/2] -learn fixes and updates Eric Wong
@ 2020-05-26  9:05 ` Eric Wong
  2020-05-26  9:05 ` [PATCH 2/2] learn: support --all with `rm' Eric Wong
  1 sibling, 0 replies; 3+ messages in thread
From: Eric Wong @ 2020-05-26  9:05 UTC (permalink / raw)
  To: meta

There is obviously a typo here, so fix it and add a test
case to guard against future regressions.

Fixes: 74a3206babe0572a ("mda: support multiple List-ID matches")
---
 script/public-inbox-learn |  2 +-
 t/mda.t                   | 10 +++++++++-
 2 files changed, 10 insertions(+), 2 deletions(-)

diff --git a/script/public-inbox-learn b/script/public-inbox-learn
index a33d813ad01..0cb2c8e96e5 100644
--- a/script/public-inbox-learn
+++ b/script/public-inbox-learn
@@ -97,7 +97,7 @@ if ($train eq 'spam') {
 	}
 	my $dests = PublicInbox::MDA->inboxes_for_list_id($pi_config, $mime);
 	for my $ibx (@$dests) {
-		next if !$seen{"$ibx"}++;
+		next if $seen{"$ibx"}++;
 		remove_or_add($ibx, $train, $mime, $ibx->{-primary_address});
 	}
 }
diff --git a/t/mda.t b/t/mda.t
index 759c0b020ab..c7caf3e0cca 100644
--- a/t/mda.t
+++ b/t/mda.t
@@ -299,9 +299,17 @@ EOF
 	ok(run_script(['-mda'], undef, $rdr),
 		'mda OK with multiple List-Id matches');
 	$cur = $git->qx(qw(diff HEAD~1..HEAD));
-	like($cur, qr/Message-ID: <2lids\@example>/,
+	like($cur, qr/^\+Message-ID: <2lids\@example>/sm,
 		'multi List-ID match delivered');
 	like($err, qr/multiple List-ID/, 'warned about multiple List-ID');
+
+	# ensure -learn rm works after inbox address is updated
+	($out, $err) = ('', '');
+	xsys(qw(git config --file), $pi_config, "$cfgpfx.address",
+		'updated-address@example.com');
+	ok(run_script(['-learn', 'rm'], undef, $rdr), 'rm-ed via -learn');
+	$cur = $git->qx(qw(diff HEAD~1..HEAD));
+	like($cur, qr/^-Message-ID: <2lids\@example>/sm, 'changed in git');
 }
 
 done_testing();

^ permalink raw reply	[flat|nested] 3+ messages in thread

* [PATCH 2/2] learn: support --all with `rm'
  2020-05-26  9:05 [PATCH 0/2] -learn fixes and updates Eric Wong
  2020-05-26  9:05 ` [PATCH 1/2] learn: fix buggy typo on List-ID mapping Eric Wong
@ 2020-05-26  9:05 ` Eric Wong
  1 sibling, 0 replies; 3+ messages in thread
From: Eric Wong @ 2020-05-26  9:05 UTC (permalink / raw)
  To: meta

I found myself wanting to remove a message from all inboxes
while working on a test case in another branch.  I figure this
could also be useful for globally removing messages which are in
the grey area or too big for spamc.
---
 Documentation/public-inbox-learn.pod | 8 ++++++--
 script/public-inbox-learn            | 9 +++++++--
 2 files changed, 13 insertions(+), 4 deletions(-)

diff --git a/Documentation/public-inbox-learn.pod b/Documentation/public-inbox-learn.pod
index addcbcb5113..9c6b261b3a5 100644
--- a/Documentation/public-inbox-learn.pod
+++ b/Documentation/public-inbox-learn.pod
@@ -50,8 +50,12 @@ C<publicinboxmda.spamcheck> is C<none> in L<public-inbox-config(5)>.
 
 =item rm
 
-This is identical to the C<spam> command above, but does
-not feed the message to L<spamc(1)>
+This is similar to the C<spam> command above, but does
+not feed the message to L<spamc(1)> and only removes messages
+which match on any of the C<To:>, C<Cc:>, and C<List-ID:> headers.
+
+The C<--all> option may be used match C<spam> semantics in removing
+the message from all configured inboxes.
 
 =back
 
diff --git a/script/public-inbox-learn b/script/public-inbox-learn
index 0cb2c8e96e5..5cd08d490bf 100644
--- a/script/public-inbox-learn
+++ b/script/public-inbox-learn
@@ -12,10 +12,15 @@ use PublicInbox::InboxWritable;
 use PublicInbox::Eml;
 use PublicInbox::Address;
 use PublicInbox::Spamcheck::Spamc;
+use Getopt::Long qw(:config gnu_getopt no_ignore_case auto_abbrev);
+my %opt = (all => 0);
+GetOptions(\%opt, 'all') or die "bad command-line args\n";
+
 my $train = shift or die "usage: $usage\n";
 if ($train !~ /\A(?:ham|spam|rm)\z/) {
 	die "`$train' not recognized.\nusage: $usage\n";
 }
+die "--all only works with `rm'\n" if $opt{all} && $train ne 'rm';
 
 my $spamc = PublicInbox::Spamcheck::Spamc->new;
 my $pi_config = PublicInbox::Config->new;
@@ -68,12 +73,12 @@ sub remove_or_add ($$$$) {
 }
 
 # spam is removed from all known inboxes since it is often Bcc:-ed
-if ($train eq 'spam') {
+if ($train eq 'spam' || ($train eq 'rm' && $opt{all})) {
 	$pi_config->each_inbox(sub {
 		my ($ibx) = @_;
 		$ibx = PublicInbox::InboxWritable->new($ibx);
 		my $im = $ibx->importer(0);
-		$im->remove($mime, 'spam');
+		$im->remove($mime, $train);
 		$im->done;
 	});
 } else {

^ permalink raw reply	[flat|nested] 3+ messages in thread

end of thread, back to index

Thread overview: 3+ messages (download: mbox.gz / follow: Atom feed)
-- links below jump to the message on this page --
2020-05-26  9:05 [PATCH 0/2] -learn fixes and updates Eric Wong
2020-05-26  9:05 ` [PATCH 1/2] learn: fix buggy typo on List-ID mapping Eric Wong
2020-05-26  9:05 ` [PATCH 2/2] learn: support --all with `rm' Eric Wong

user/dev discussion of public-inbox itself

Archives are clonable:
	git clone --mirror https://public-inbox.org/meta
	git clone --mirror http://czquwvybam4bgbro.onion/meta
	git clone --mirror http://hjrcffqmbrq6wope.onion/meta
	git clone --mirror http://ou63pmih66umazou.onion/meta

Example config snippet for mirrors

Newsgroups are available over NNTP:
	nntp://news.public-inbox.org/inbox.comp.mail.public-inbox.meta
	nntp://ou63pmih66umazou.onion/inbox.comp.mail.public-inbox.meta
	nntp://czquwvybam4bgbro.onion/inbox.comp.mail.public-inbox.meta
	nntp://hjrcffqmbrq6wope.onion/inbox.comp.mail.public-inbox.meta
	nntp://news.gmane.io/gmane.mail.public-inbox.general

 note: .onion URLs require Tor: https://www.torproject.org/

AGPL code for this site: git clone https://public-inbox.org/public-inbox.git